/* $Header */

#include <windows.h>
#include <string.h>
// #include <stdlib.h>
#include <ctype.h>
// #include <limits.h>
#include <time.h>
#include "exports.h"
#include "cwstart.h"

#define	strchr(x, y)	_fstrchr((x), (y))


LIBMAIN

void DLL
_init()
{
	LibExport( "void BufInsertDate LPSTR");
}


/*
 * Offsets of various fields into the string
 * returned by ctime()
 */
#define	OFF_WEEK	(0)
#define	OFF_MONTH	(4)
#define	OFF_DAY		(8)
#define	OFF_HOUR	(11)
#define	OFF_MINUTE	(14)
#define	OFF_SECOND	(17)
#define	OFF_CENTURY	(20)
#define	OFF_YEAR	(22)

/*
 * Sizes of various fields into the string
 * returned by ctime()
 */
#define	SIZ_WEEK	(3)
#define	SIZ_MONTH	(3)
#define	SIZ_DAY		(2)
#define	SIZ_HOUR	(2)
#define	SIZ_MINUTE	(2)
#define	SIZ_SECOND	(2)
#define	SIZ_CENTURY	(2)
#define	SIZ_YEAR	(2)

/*
 * Abbreviations for the names of the months,
 * in order of importance.
 */
char *monStrs[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec", NULL };
	
char *numStrs[] = { "1", "2", "3", "4", "5", "6",
	"7", "8", "9", "10", "11", "12", NULL };

void DLL
BufInsertDate(LPSTR fmt)
{
	char *timbu;
	LPSTR strarr[26] = {NULL,};
	LPSTR retstr = NULL;
	int c;
	static char chstr[3] = " ";
	static time_t timebuffer;
	static char timestring[26];
	char **monp;
	
	if (ArgCount() < 1 || !fmt)
		fmt = "W N D H:M:S CY";
		
	time(&timebuffer);	
	timbu = StrNew((LPSTR)ctime(&timebuffer));
	
	strarr['W' - 'A'] = StrNNew(timbu + OFF_WEEK, SIZ_WEEK);
	strarr['N' - 'A'] = StrNNew(timbu + OFF_MONTH, SIZ_MONTH);
	strarr['D' - 'A'] = StrNNew(timbu + OFF_DAY, SIZ_DAY);
	strarr['H' - 'A'] = StrNNew(timbu + OFF_HOUR, SIZ_HOUR);
	strarr['M' - 'A'] = StrNNew(timbu + OFF_MINUTE, SIZ_MINUTE);
	strarr['S' - 'A'] = StrNNew(timbu + OFF_SECOND, SIZ_SECOND);
	strarr['C' - 'A'] = StrNNew(timbu + OFF_CENTURY, SIZ_CENTURY);
	strarr['Y' - 'A'] = StrNNew(timbu + OFF_YEAR, SIZ_YEAR);
	
	while (*fmt)
	{
		if (isalpha(*fmt))
			c = toupper(*fmt);
		else
			c = *fmt;	
		if (c == 'T')
		{
			for (monp = monStrs; *monp; ++monp)
				if (!strncmp(*monp, strarr['N' - 'A'], 3))
					retstr = StrAppend(retstr, numStrs[monp - monStrs]);
		}
		else if (strchr("WNDHMSCY", c))
			retstr = StrAppend(retstr, strarr[c - 'A']);
		else
		{
			chstr[0] = c;
			retstr = StrAppend(retstr, chstr);
		}
		++fmt;	
	}
	BufInsertStr(retstr);
	StrFree(retstr);
	for (c = 'A'; c <= 'Z'; ++c)
	{
		if (strchr("WNDHMSTCY", c))
			StrFree(strarr[c - 'A']);
	}
}

